/*
 * lilJudd
 * Copyright (C) 2023 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.lilJudd.jobs.component

import dev.inmo.krontab.KronScheduler
import kotlinx.coroutines.Job

interface ICronjob {
    val jobName: String

    /*  /--------------- Seconds
        | /------------- Minutes
        | | /----------- Hours
        | | | /--------- Days of months
        | | | | /------- Months
        | | | | | /----- (optional) Year
        | | | | | | /--- (optional) Timezone offset
        | | | | | | |  / (optional) Week days
        * * * * * * 0o *w
    */

    val jobIncoming: String
    val jobType: CronjobType

    val continueJob: Boolean

    var cronjobJob: Job
    var scheduler: KronScheduler
    suspend fun jobFunction()

}
